#ifndef QTERM_H
#define QTERM_H
#include <qmainwindow.h>
#include "global.h"
class QToolBar;
class QPopupMenu;
class QWorkspace;
class QPopupMenu;
class QTabBar;
class QTab;
class QTermWindow;
class QTermWndMgr;

class QuickLogin;
class addrDialog;

class QTerm: public QMainWindow
{
    Q_OBJECT
public:
    QTerm();
    ~QTerm();

public slots:
    void newWindow();
    void closeWindow();

    void about();
    void aboutQt();
	
    void windowsMenuAboutToShow();
    void windowsMenuActivated( int id );

    void selectChange(int);
    void addressBook();
    void quickLogin();
    
    void font();

    virtual void closeEvent(QCloseEvent *);
    
public:   
    QWorkspace* ws;
    QToolBar *connectTools;
    QPopupMenu* windowsMenu;
    QTabBar *tabBar;
    QTermWndMgr* wndmgr;
    QuickLogin* login;
    addrDialog* addr;
    QString strHost;
    QStringList addrParam;
    char cfgFile[BUFSIZE];
public:

    void savePosition();
};

#endif

